summaryrefslogtreecommitdiffstats
path: root/source/ap/sysstat/sysstat.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'source/ap/sysstat/sysstat.SlackBuild')
-rwxr-xr-xsource/ap/sysstat/sysstat.SlackBuild111
1 files changed, 81 insertions, 30 deletions
diff --git a/source/ap/sysstat/sysstat.SlackBuild b/source/ap/sysstat/sysstat.SlackBuild
index 399bb4bd4..5f5c0cfb1 100755
--- a/source/ap/sysstat/sysstat.SlackBuild
+++ b/source/ap/sysstat/sysstat.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2006, 2008, 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2006, 2008, 2009, 2010 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -22,13 +22,42 @@
PKGNAM=sysstat
-VERSION=${VERSION:-7.0.0}
-ARCH=${ARCH:-x86_64}
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
BUILD=${BUILD:-1}
-if [ "$ARCH" = "x86_64" ]; then
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+ ARCHQUADLET=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+ ARCHQUADLET=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
LIBDIRSUFFIX="64"
+ ARCHQUADLET=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ ARCHQUADLET=""
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "arm" ]; then
+ SLKCFLAGS="-O2 -march=armv4t"
+ LIBDIRSUFFIX=""
+ ARCHQUADLET="-gnueabi"
else
+ SLKCFLAGS="-O2"
+ ARCHQUADLET=""
LIBDIRSUFFIX=""
fi
@@ -40,8 +69,8 @@ mkdir -p $TMP $PKG
cd $TMP
rm -rf ${PKGNAM}-${VERSION}
-tar xjvf $CWD/${PKGNAM}-$VERSION.tar.bz2
-cd ${PKGNAM}-$VERSION
+tar xvf $CWD/${PKGNAM}-$VERSION.tar.?z* || exit 1
+cd ${PKGNAM}-$VERSION || exit 1
# Make sure ownerships and permissions are sane:
chown -R root:root .
@@ -51,25 +80,31 @@ find . \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \;
-# Put the config file in /etc/sysstat, not /etc/sysconfig (a Red Hat thing):
-zcat $CWD/sysstat.etc.sysstat.diff.gz | patch -p1 --verbose || exit 1
-
-# PREFIX is hardcoded in some places, so this is just easier:
-zcat $CWD/sysstat.prefix.usr.diff.gz | patch -p1 --verbose || exit 1
-
-# Don't use /tmp in a script root will probably run... that's not good.
-zcat $CWD/sysstat.var.run.diff.gz | patch -p1 --verbose || exit 1
-
-make SA_LIB_DIR=/usr/lib${LIBDIRSUFFIX}/sa DESTDIR=$PKG || exit 1
-make install SA_LIB_DIR=/usr/lib${LIBDIRSUFFIX}/sa DESTDIR=$PKG || exit 1
-
-# Yeah, technically this is an init script that could go in /etc/rc.d/, but
-# I'd rather not put too many things in there. If you need this, I'm sure
-# you will find it here:
-mkdir -p $PKG/etc/sysstat
-cp -a sysstat $PKG/etc/sysstat/sysstat
-chown root:root $PKG/etc/sysstat/sysstat
-chmod 755 $PKG/etc/sysstat/sysstat
+# Configure:
+CFLAGS="$SLKCFLAGS -DSADC_PATH=/usr/lib$LIBDIRSUFFIX/sa/sadc" \
+./configure \
+ --disable-man-group \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ conf_dir=/etc/sysstat \
+ sa_lib_dir=/usr/lib$LIBDIRSUFFIX/sa \
+ --libdir=/usr/lib$LIBDIRSUFFIX \
+ --infodir=/usr/info \
+ --docdir=/usr/doc/sysstat-$VERSION \
+ --mandir=/usr/man \
+ --disable-static \
+ --build=$ARCH-slackware-linux$ARCHQUADLET || exit 1
+
+# Build and install:
+make $NUMJOBS || make || exit 1
+make install IGNORE_MAN_GROUP=y DESTDIR=$PKG || exit 1
+
+mv $PKG/etc/sysstat/sysstat $PKG/etc/sysstat/sysstat.new
+
+mkdir -p $PKG/etc/rc.d
+# Cosmetic touches:
+sed -i 's?/etc/rc.d/init.d/sysstat?/etc/rc.d/rc.sysstat?g' sysstat
+install -o0 -g0 -vpm644 sysstat $PKG/etc/rc.d/rc.sysstat.new
# Strip binaries:
( cd $PKG
@@ -92,14 +127,30 @@ if [ -d $PKG/usr/man ]; then
)
fi
-# Fix the documentation directory to preserve timestamps:
-mkdir -p $PKG/usr/doc/${PKGNAM}-$VERSION
-rm -f $PKG/usr/doc/${PKGNAM}-$VERSION/*
+# Adjust the docs so that they are Slackware-locationised:
+# We ignore the 'CHANGES' since they aren't relevant to the running of the system.
+sed -i 's?/etc/sysconfig?/etc/sysstat?g' $PKG/usr/doc/$PKGNAM-$VERSION/{README,FAQ}
+# "make install" installs the docs but doesn't preserve the time stamps:
+for docfile in $( cd $PKG/usr/doc/$PKGNAM-$VERSION ; ls -1 ) ; do
+ touch -d "$( find $docfile -printf "%t\n" )" $PKG/usr/doc/$PKGNAM-$VERSION/$docfile
+done
+# Add crontab example scripts:
+mkdir -p $PKG/usr/doc/${PKGNAM}-$VERSION/cron-examples
cp -a \
- COPYING CREDITS FAQ README TODO sysstat-7.0.0.lsm \
- $PKG/usr/doc/${PKGNAM}-$VERSION
+ crontab sysstat.cron.daily sysstat.cron.hourly sysstat.crond \
+ sysstat.crond.sample \
+ $PKG/usr/doc/${PKGNAM}-$VERSION/cron-examples
+
+# If there's a CHANGES file, installing at least part of the recent history
+# is useful, but don't let it get totally out of control:
+if [ -r CHANGES ]; then
+ DOCSDIR=$(echo $PKG/usr/doc/${PKGNAM}-$VERSION)
+ cat CHANGES | head -n 1000 > $DOCSDIR/CHANGES
+ touch -r CHANGES $DOCSDIR/CHANGES
+fi
mkdir -p $PKG/install
+zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
cat $CWD/slack-desc > $PKG/install/slack-desc
cd $TMP/package-${PKGNAM}